/* LaTeX2Sdoc
 *  Copyright (C) 2000-2001 SAKURAI, Masashi (m.sakurai@cmt.phys.kyushu-u.ac.jp)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
package jp.gr.java_conf.ccs2.tool.tex2sdoc.math;

import java.util.*;
import jp.gr.java_conf.ccs2.jdk11.util.TreeStructure;

public class CommandContent extends Content {

    Vector args;
    String option;

    public CommandContent(String c) {
	super(c);
    }

    public void setOption(String o){
	option = o;
    }
    public String getOption() {
	return option;
    }

    public void addArgument(Element el) {
	if (args == null)
	    args = new Vector();
	args.addElement( el );
    }

    public Element [] getArguments() {
	if (args == null) return null;
	Element [] tree = new Element[args.size()];
	for (int i=0;i<tree.length;i++)
	tree[i] = (Element)args.elementAt(i);
	return tree;
    }

    //used by re-arrange indexies of arguments
    public void arrangeArguments(int [] indexies) {
	Element [] tmp = getArguments();
	args = new Vector();
	for (int i=0;i<indexies.length;i++) {
	    addArgument(tmp[indexies[i]]);
	}
    }

    // tree

    public String getTreeNodeExpression() {
	return "CMD:"+getContent();
    }

    public TreeStructure [] getTreeNodes() {
	Element [] ts = getArguments();
	if (ts == null) return null;
	TreeStructure [] tree = new TreeStructure[ts.length];
	for (int i=0;i<ts.length;i++)
	tree[i] = (TreeStructure)ts[i];
	return tree;
    }
}
