/* LaTeX2Sdoc
 *  Copyright (C) 2000-2001 SAKURAI, Masashi 
 *  (m.sakurai@cmt.phys.kyushu-u.ac.jp)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

package jp.gr.java_conf.ccs2.tool.tex2sdoc.math;


public class TeX2MathMLException extends Exception {
    
    String input,message;
    int rows,cols;

    public TeX2MathMLException(String input,String message,
			       int rows,int col) {
	this.input = input;
	this.message = message;
	this.rows = rows;
	this.cols = cols;
    }

    public String getErrorInput() {return input;}
    public String getErrorMessage() {return message;}
    public int getErrorRows() {return rows;}
    public int getErrorCols() {return cols;}

    public String getMessage() {
	StringBuffer sb = new StringBuffer();
	sb.append("TeX2MathML got error ["+message+"]\n");
	sb.append("----(input)----------------------------\n");
	sb.append(input+"\n");
	sb.append("---------------------------------------\n");
	sb.append("Rows:"+rows+"   Cols:"+cols+"\n");
	return sb.toString();
    }
}
