/* LaTeX2Sdoc
 *  Copyright (C) 2000-2001 SAKURAI, Masashi (m.sakurai@cmt.phys.kyushu-u.ac.jp)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
package jp.gr.java_conf.ccs2.tool.tex2sdoc.math;
import jp.gr.java_conf.ccs2.jdk11.util.TreeStructure;
import java.util.Vector;

public class Term implements TreeStructure {

    Element body,sub,sup;

    public Term() {
    }

    public void setBodyElement(Element e) {
	body = e;
    }
    public void setSubElement(Element e) {
	sub = e;
    }
    public void setSupElement(Element e) {
	sup = e;
    }
    public Element getBodyElement() {
	return body;
    }
    public Element getSubElement() {
	return sub;
    }
    public Element getSupElement() {
	return sup;
    }


    // TreeStructure

    public String getTreeNodeExpression() {
	String ret = "Term";
	if (body != null) ret += "{}";
	if (sub != null) ret += "_";
	if (sup != null) ret += "^";
	return ret;
    }

    public TreeStructure [] getTreeNodes() {
	Vector t = new Vector();
	if (body != null) t.addElement(body);
	if (sub != null) t.addElement(sub);
	if (sup != null) t.addElement(sup);
	TreeStructure [] rets = new TreeStructure[t.size()];
	for (int i=0;i<rets.length;i++) {
	    rets[i] = (TreeStructure)t.elementAt(i);
	}
	return rets;
    }
    
}
