/* LaTeX2Sdoc
 *  Copyright (C) 2000-2001 SAKURAI, Masashi (m.sakurai@cmt.phys.kyushu-u.ac.jp)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
package jp.gr.java_conf.ccs2.tool.tex2sdoc.math;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import jp.gr.java_conf.ccs2.jdk11.util.*;

public class TestApplet extends Applet {
    
    TextArea inputText;
    TextArea outputText;
    Button exec;
    Button clear;

    TeX2MathML engine = new TeX2MathML();

    public void init() {
	// init parameter
	String initCode = getParameter("init");
	if (initCode == null) {
	    initCode = "x^2+5x+6";
	}

	this.setLayout( new BorderLayout() );
	//button panel
	Panel buttons = new Panel( new FlowLayout() );
	exec = new Button("translate!");
	exec.addActionListener( new ActionListener() {
		public void actionPerformed(ActionEvent e) {
		    onExec();
		}
	    });
	buttons.add(exec);
	clear = new Button("clear");
	clear.addActionListener( new ActionListener() {
		public void actionPerformed(ActionEvent e) {
		    onClear();
		}
	    });
	buttons.add(clear);
	buttons.add(new Label("Write TeX exp and push [translate] button."));
	this.add("North",buttons);

	//
	Panel inputs = new Panel(new BorderLayout());
	inputs.add("North",new Label("<LaTeX math expression>"));
	inputText = new TextArea(3,50);
	inputText.setText( initCode );
	inputs.add("Center",inputText);
	this.add("Center",inputs);
	//
	Panel outputs = new Panel(new BorderLayout());
	outputs.add("North",new Label("<MathML expression (Display style) >"));
	outputText = new TextArea(10,50);
	outputs.add("Center",outputText);
	this.add("South",outputs);
    }

    void onClear() {
	inputText.setText("");
	outputText.setText("");
    }

    void onExec() {
	String a = inputText.getText();
	if (a == null) return;
	//
	String ret = "";
	try {
	    ret = engine.translate( a );
	    //
	    ret += "\n\n";
	    ret += engine.getLog();
	} catch (TeX2MathMLException e) {
	    ret = e.getMessage();
	} catch (RuntimeException e) {
	    ret = "RuntimeException (Bug!) : ["+e.getClass().getName()+"]\n";
	    ret += e.getMessage() + "\n";
	}
	outputText.setText( ret );
    }
}
