/* LaTeX2Sdoc
 *  Copyright (C) 2000-2001 SAKURAI, Masashi (m.sakurai@cmt.phys.kyushu-u.ac.jp)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
package jp.gr.java_conf.ccs2.tool.tex2sdoc.math.handler;
import jp.gr.java_conf.ccs2.tool.tex2sdoc.math.*;
import jp.gr.java_conf.ccs2.tool.tex2sdoc.*;

/**
   TeX -> MathML Split Environment handler
 */
public class MultilineEnvHandler implements MathMLEnvHandler {

    String content;

    public MultilineEnvHandler(String content) {
	this.content = content;
    }

    public void onEnvBegin(MathMLVisitor parent) {
	parent.addString(
	    TagUtil.makeBtag(parent,"mtable") );
    }

    public void onEnvEnd(MathMLVisitor parent) {
	parent.addString( TagUtil.makeEtag(parent,"mtable") );
    }

    public void onContentOut(MathMLVisitor parent) throws ParseException {
	String [][] array = TeXUtil.makeArray(content);
	String [] align = new String[array.length];
	align[0] = "left";
	align[align.length-1] = "right";
	for (int i=1;i<(array.length-1);i++) {
	    align[i] = "center";
	}
	TeX2MathML eng = new TeX2MathML();
	//
	for(int i=0;i<array.length;i++) {
	    parent.addString( TagUtil.makeBtag(parent,"mtr"));
	    parent.addString( TagUtil.makeBtagWithAttr(
		parent,"mtd","columnalign",align[i]) );
	    parent.incTab();
	    for (int j=0;j<array[0].length;j++) {
		String out = eng.translate_gen(array[i][j],parent);
		parent.addString( out );
	    }
	    parent.decTab();
	    parent.addString( TagUtil.makeEtag(parent,"mtd") );
	    parent.addString( TagUtil.makeEtag(parent,"mtr") );
	}
	parent.log(eng.getLog());
    }

}
