/* LaTeX2Sdoc
 * Copyright (C) 2000-2001 SAKURAI, Masashi (m.sakurai@cmt.phys.kyushu-u.ac.jp)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
package jp.gr.java_conf.ccs2.tool.tex2sdoc.math.handler;
import jp.gr.java_conf.ccs2.tool.tex2sdoc.math.*;
import jp.gr.java_conf.ccs2.jdk11.util.StringUtil;

/**
   SimpleTemporaryCommandHandler 
 */
public class SimpleTemporaryCommandHandler extends TemporaryCommandHandler {

    String tagname,attrs;

    public SimpleTemporaryCommandHandler(String tagname) {
	String [] rets = StringUtil.split(tagname,"@");
	this.tagname = rets[0];
	if (rets.length == 2)
	    this.attrs = rets[1];
    }
    
    protected SimpleTemporaryCommandHandler(String t,String a) {
	this.tagname = t;
	this.attrs = a;
    }
    
    protected String operateCommand(MathMLVisitor parent) {
	parent.addString( TagUtil.makeBtagWithAttrs(
	    parent,tagname,attrs) );
	//hack current place
	return TagUtil.makeEtag(parent,tagname);
    }

    public String toString() {
	String ret = "Intr. Cmd ["+tagname+"] ["+attrs+"]";
	return ret;
    }

    public MathMLCommandHandler getCopy(CommandContent c) {
	return new SimpleTemporaryCommandHandler(tagname,attrs);
    }

}
