/* LaTeX2Sdoc
 *  Copyright (C) 2000-2001 SAKURAI, Masashi (m.sakurai@cmt.phys.kyushu-u.ac.jp)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
package jp.gr.java_conf.ccs2.tool.tex2sdoc.math.handler;
import jp.gr.java_conf.ccs2.tool.tex2sdoc.math.*;
import jp.gr.java_conf.ccs2.tool.tex2sdoc.*;

/**
   TeX -> MathML Split Environment handler
 */
public class SplitEnvHandler implements MathMLEnvHandler {

    String content;
    String [][] array;

    public SplitEnvHandler(String content) {
	this.content = content;
	array = TeXUtil.makeArray(content);
    }

    public void onEnvBegin(MathMLVisitor parent) {
	String ga = "";
	for (int i=0;i<array[0].length;i++) {
	    ga += "left ";
	}
	parent.addString( 
	    TagUtil.makeBtagWithAttr(
		parent,"mtable","groupalign",ga) );
    }

    public void onEnvEnd(MathMLVisitor parent) {
	parent.addString( TagUtil.makeEtag(parent,"mtable") );
    }

    public void onContentOut(MathMLVisitor parent) throws ParseException {
	TeX2MathML eng = new TeX2MathML();
	//
	for(int i=0;i<array.length;i++) {
	    parent.addString( TagUtil.makeBtag(parent,"mtr") );
	    parent.incTab();
	    for (int j=0;j<array[0].length;j++) {
		parent.addString( 
		    TagUtil.makeEmptyTag(parent,"maligngroup",null) );
		String out = eng.translate_gen(array[i][j],parent);
		parent.addString( out );
	    }
	    parent.decTab();
	    parent.addString( TagUtil.makeEtag(parent,"mtr") );
	}
	parent.log(eng.getLog());
    }

}
